#ifndef XINEMACONTROLITEM_H_
#define XINEMACONTROLITEM_H_

#include <QQuickItem>
#include "xinemacontrol.h"

class XinemaControlItem: public QQuickItem
{
	Q_OBJECT

	Q_PROPERTY(bool connected READ is_connected NOTIFY connect_state_changed)

private:
	XinemaControl control;

public:
	XinemaControlItem();

	XinemaControl &get_control() { return control; }
	Q_INVOKABLE void connect(const QString &);
	bool is_connected() const;

	Q_INVOKABLE void play_file(const QString &);

signals:
	void connect_state_changed();
};

#endif
